16df3bb5966c5a4c3301f82dccdbc758b2eba3ff
[yardstick.git] / tests / ci / yardstick-verify
1 #!/bin/bash
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 #
12 # Set up the environment and run yardstick test suites.
13 #
14 # Example invocation: yardstick-verify -r 10.4.4.4 suite1.yaml suite2.yaml
15 #
16 # Openstack credentials must be set and the script must be run from its
17 # original location in the yardstick repo.
18 #
19 # This script is intended to be used by the CI pipeline but it may also
20 # be invoked manually.
21 #
22
23 SCRIPT=$0
24 SCRIPT_ARGS=$@
25
26 usage()
27 {
28     cat << EOF
29 usage: $0 options [TEST_SUITE ...]
30
31 If no test suites are given ping.yaml is run.
32
33 OPTIONS:
34    -h      Show this message
35    -r      Http target (example: -r 213.77.62.197/results)
36    -i      Influxdb target (example: -i 127.0.0.1:8086)
37
38            Default target is dump to file ($DISPATCHER_FILE_NAME)
39
40 EOF
41 }
42
43 DISPATCHER_TYPE=file
44 DISPATCHER_FILE_NAME="/tmp/yardstick.out"
45 DISPATCHER_HTTP_TARGET="http://testresults.opnfv.org/test/api/v1/results"
46 DISPATCHER_INFLUXDB_TARGET=
47 UCA_HOST="cloud-images.ubuntu.com"
48 if [ $YARD_IMG_ARCH = "arm64" ]; then
49     export VIVID_IMG_URL="http://${UCA_HOST}/vivid/current/vivid-server-cloudimg-arm64.tar.gz"
50     if ! grep -q "Defaults env_keep += \"VIVID_IMG_URL\"" "/etc/sudoers"; then
51         sudo echo "Defaults env_keep += \"VIVID_IMG_URL\"" >> /etc/sudoers
52     fi
53 fi
54 while getopts "r:i:h" OPTION; do
55     case $OPTION in
56         h)
57             usage
58             exit 0
59             ;;
60         r)
61             DISPATCHER_TYPE=http
62             DISPATCHER_HTTP_TARGET=http://${OPTARG}
63             DISPATCHER_FILE_NAME=
64             ;;
65         i)
66             DISPATCHER_TYPE=influxdb
67             DISPATCHER_INFLUXDB_TARGET=http://${OPTARG}
68             DISPATCHER_FILE_NAME=
69             ;;
70         *)
71             echo "${OPTION} is not a valid argument"
72             exit 1
73             ;;
74     esac
75 done
76
77 shift $[OPTIND - 1]
78 TEST_SUITES=$@
79
80 cleanup()
81 {
82     echo
83     echo "========== Cleanup =========="
84
85     if ! glance image-list; then
86         return
87     fi
88
89     for image in $(glance image-list | grep -e cirros-0.3.3 -e yardstick-trusty-server -e Ubuntu-14.04 \
90         -e yardstick-vivid-kernel | awk '{print $2}'); do
91         echo "Deleting image $image..."
92         glance image-delete $image || true
93     done
94
95     nova flavor-delete yardstick-flavor &> /dev/null || true
96 }
97
98 exitcode=""
99
100 error_exit()
101 {
102     local rc=$?
103
104     if [ -z "$exitcode" ]; then
105         # In case of recursive traps (!?)
106         exitcode=$rc
107     fi
108
109     cleanup
110
111     echo "Exiting with RC=$exitcode"
112
113     exit $exitcode
114 }
115
116 set -o errexit
117 set -o pipefail
118
119 install_yardstick()
120 {
121     echo
122     echo "========== Installing yardstick =========="
123
124     # uninstall previous version
125     pip uninstall -y yardstick || true
126
127     # Install yardstick
128     pip install .
129 }
130
131 install_storperf()
132 {
133     # Install Storper on huawei-pod1
134     if [ "$NODE_NAME" == "huawei-pod1" ]; then
135         echo
136         echo "========== Installing storperf =========="
137
138         if ! yardstick -d plugin install plugin/CI/storperf.yaml; then
139             echo "Install storperf plugin FAILED";
140             exit 1
141         fi
142
143     fi
144 }
145
146 remove_storperf()
147 {
148     # remove Storper from huawei-pod1
149     if [ "$NODE_NAME" == "huawei-pod1" ]; then
150         echo
151         echo "========== Removing storperf =========="
152
153         if ! yardstick -d plugin remove plugin/CI/storperf.yaml; then
154             echo "Remove storperf plugin FAILED";
155             exit 1
156         fi
157
158     fi
159 }
160
161 build_yardstick_image()
162 {
163     echo
164     echo "========== Build yardstick cloud image =========="
165
166     local cmd="sudo $(which yardstick-img-modify) $(pwd)/tools/ubuntu-server-cloudimg-modify.sh"
167
168     # Build the image. Retry once if the build fails.
169     $cmd || $cmd
170
171     if [ ! -f $QCOW_IMAGE ]; then
172         echo "Failed building QCOW image"
173         exit 1
174     fi
175 }
176
177 create_nova_flavor()
178 {
179     if ! nova flavor-list | grep -q yardstick-flavor; then
180         echo
181         echo "========== Create nova flavor =========="
182         # Create the nova flavor used by some sample test cases
183         nova flavor-create yardstick-flavor 100 512 3 1
184         # DPDK-enabled OVS requires guest memory to be backed by large pages
185         if [[ "$DEPLOY_SCENARIO" == *"-ovs-"* ]]; then
186             nova flavor-key yardstick-flavor set hw:mem_page_size=large
187         fi
188     fi
189 }
190
191 load_cirros_image()
192 {
193     echo
194     echo "========== Loading cirros cloud image =========="
195
196     local image_file=/home/opnfv/images/cirros-0.3.3-x86_64-disk.img
197
198     output=$(glance image-create \
199         --name  cirros-0.3.3 \
200         --disk-format $DISK_FORMAT \
201         --container-format bare \
202         --file $image_file)
203     echo "$output"
204
205     CIRROS_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
206     if [ -z "$CIRROS_IMAGE_ID" ]; then
207         echo 'Failed uploading cirros image to cloud'.
208         exit 1
209     fi
210
211     echo "Cirros image id: $CIRROS_IMAGE_ID"
212 }
213
214 load_ubuntu_image()
215 {
216     echo
217     echo "========== Loading ubuntu cloud image =========="
218
219     local ubuntu_image_file=/home/opnfv/images/trusty-server-cloudimg-amd64-disk1.img
220
221     output=$(glance image-create \
222         --name Ubuntu-14.04 \
223         --disk-format qcow2 \
224         --container-format bare \
225         --file $ubuntu_image_file)
226     echo "$output"
227
228     UBUNTU_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
229
230     if [ -z "$UBUNTU_IMAGE_ID" ]; then
231         echo 'Failed uploading UBUNTU image to cloud'.
232         exit 1
233     fi
234
235     echo "Ubuntu image id: $UBUNTU_IMAGE_ID"
236 }
237
238 load_yardstick_image()
239 {
240     echo
241     echo "========== Loading yardstick cloud image =========="
242     EXTRA_PARAMS=""
243     if [ $YARD_IMG_ARCH = "arm64" ]; then
244         VIVID_IMAGE="/tmp/vivid-server-cloudimg-arm64.tar.gz"
245         VIVID_KERNEL="/tmp/vivid-server-cloudimg-arm64-vmlinuz-generic"
246         cd /tmp
247         if [ ! -f $VIVID_IMAGE ]; then
248             wget $VIVID_IMG_URL
249         fi
250         if [ ! -f $VIVID_KERNEL ]; then
251             tar zxf $VIVID_IMAGE $(basename $VIVID_KERNEL)
252         fi
253         create_vivid_kernel=$(glance --os-image-api-version 1 image-create \
254                 --name yardstick-vivid-kernel \
255                 --is-public true --disk-format qcow2 \
256                 --container-format bare \
257                 --file $VIVID_KERNEL)
258
259         GLANCE_KERNEL_ID=$(echo "$create_vivid_kernel" | grep " id " | awk '{print $(NF-1)}')
260         if [ -z "$GLANCE_KERNEL_ID" ]; then
261             echo 'Failed uploading kernel to cloud'.
262             exit 1
263         fi
264
265         command_line="root=/dev/vdb1 console=tty0 console=ttyS0 console=ttyAMA0 rw"
266
267         EXTRA_PARAMS="--property kernel_id=$GLANCE_KERNEL_ID --property os_command_line=\"$command_line\""
268
269         rm -f $VIVID_KERNEL $VIVID_IMAGE
270         cd $YARDSTICK_REPO_DIR
271     fi
272
273     output=$(eval glance --os-image-api-version 1 image-create \
274         --name yardstick-trusty-server \
275         --is-public true --disk-format $DISK_FORMAT \
276         --container-format bare \
277         $EXTRA_PARAMS \
278         --file $QCOW_IMAGE)
279
280     echo "$output"
281
282     GLANCE_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
283
284     if [ -z "$GLANCE_IMAGE_ID" ]; then
285         echo 'Failed uploading image to cloud'.
286         exit 1
287     fi
288
289     sudo rm -f $QCOW_IMAGE
290
291     echo "Glance image id: $GLANCE_IMAGE_ID"
292 }
293
294 report(){
295
296     echo
297     echo "========== Reporting Status =========="
298     curl -i -H 'content-type: application/json' -X POST -d \
299         "{\"project_name\": \"yardstick\",
300           \"case_name\": \"scenario_status\",
301           \"pod_name\":\"${NODE_NAME}\",
302           \"installer\":\"${INSTALLER_TYPE}\",
303           \"version\":\"$(basename ${YARDSTICK_BRANCH})\",
304           \"scenario\":\"${DEPLOY_SCENARIO}\",
305           \"description\": \"yardstick ci scenario status\",
306           \"criteria\":\"$1\",
307           \"start_date\":\"$2\",
308           \"stop_date\":\"$3\",
309           \"details\":\"\"}" \
310           ${DISPATCHER_HTTP_TARGET}
311 }
312
313 run_test()
314 {
315     echo
316     echo "========== Running yardstick test suites =========="
317
318     mkdir -p /etc/yardstick
319
320     cat << EOF >> /etc/yardstick/yardstick.conf
321 [DEFAULT]
322 debug = True
323 dispatcher = ${DISPATCHER_TYPE}
324
325 [dispatcher_file]
326 file_name = ${DISPATCHER_FILE_NAME}
327
328 [dispatcher_http]
329 timeout = 5
330 target = ${DISPATCHER_HTTP_TARGET}
331
332 [dispatcher_influxdb]
333 timeout = 5
334 target = ${DISPATCHER_INFLUXDB_TARGET}
335 db_name = yardstick
336 username = opnfv
337 password = 0pnfv2015
338 EOF
339
340     local failed=0
341     local start_date
342     local stop_date
343
344     if [ ${#SUITE_FILES[@]} -gt 0 ]; then
345
346         start_date=$(date '+%Y-%m-%d %H:%M:%S')
347         for suite in ${SUITE_FILES[*]}; do
348
349             echo "---------------------------"
350             echo "Running test suite: $suite"
351             echo "---------------------------"
352             if ! yardstick task start --suite $suite; then
353                  echo "test suite $suite FAILED";
354
355                 # Mark the test suite failed but continue
356                 # running the remaining test suites.
357                 (( ++failed ))
358             fi
359             if [ ${DISPATCHER_TYPE} = file ]; then
360                 echo "---------------------------"
361                 echo "Dump test suite $suite result"
362                 echo "---------------------------"
363                 if [ -f ${DISPATCHER_FILE_NAME} ]; then
364                     cat ${DISPATCHER_FILE_NAME}
365                 else
366                     echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
367                 fi
368             fi
369         done
370         stop_date=$(date '+%Y-%m-%d %H:%M:%S')
371
372
373
374         local scenario_status="SUCCESS"
375
376         if [ $failed -gt 0 ]; then
377             scenario_status="FAILED"
378         fi
379
380         report $scenario_status $start_date $stop_date
381
382         if [ $failed -gt 0 ]; then
383             echo "---------------------------"
384             echo "$failed out of ${SUITE_FILES[*]} test suites FAILED"
385             echo "---------------------------"
386             exit 1
387         fi
388
389     else
390
391         echo "---------------------------"
392         echo "Running samples/ping.yaml  "
393         echo "---------------------------"
394
395         if ! yardstick task start samples/ping.yaml; then
396             echo "Yardstick test FAILED"
397             exit 1
398         fi
399
400         if [ ${DISPATCHER_TYPE} = file ]; then
401             echo "---------------------------"
402             echo "Dump samples/ping.yaml test result"
403             echo "---------------------------"
404             if [ -f ${DISPATCHER_FILE_NAME} ]; then
405                 cat ${DISPATCHER_FILE_NAME}
406             else
407                 echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
408             fi
409         fi
410
411     fi
412
413 }
414
415 main()
416 {
417     GITROOT=$(cd $(dirname $0) && git rev-parse --show-toplevel)
418
419     cd $GITROOT
420
421     export YARDSTICK_VERSION=$(git rev-parse HEAD)
422
423     SUITE_FILES=()
424
425     # find the test suite files
426     for suite in $TEST_SUITES; do
427         if [ -f $suite ]; then
428             SUITE_FILES+=($suite)
429         else
430             tsdir=$GITROOT/tests/opnfv/test_suites
431             if [ ! -f $tsdir/$suite ]; then
432                 echo "Test suite \"$suite\" does not exist"
433                 exit 1
434             fi
435             SUITE_FILES+=($tsdir/$suite)
436         fi
437     done
438
439     echo
440     echo "========== Running Yardstick CI with following parameters =========="
441     echo "Script options: ${SCRIPT} $SCRIPT_ARGS"
442     echo "Dispatcher: ${DISPATCHER_TYPE} ${DISPATCHER_FILE_NAME}"
443     echo "YARDSTICK_VERSION: ${YARDSTICK_VERSION}"
444     echo "Number of test suites: ${#SUITE_FILES[@]}"
445     for suite in ${SUITE_FILES[*]}; do
446         echo "     $suite"
447     done
448     echo
449
450     # check if some necessary variables is set
451     if [ -z "$OS_AUTH_URL" ]; then
452         echo "OS_AUTH_URL is unset or empty"
453         exit 1
454     fi
455
456     echo "OS_AUTH_URL is $OS_AUTH_URL"
457     echo
458
459     # check OpenStack services
460     echo "Checking OpenStack services:"
461     for cmd in "glance image-list" "nova list" "heat stack-list"; do
462         echo "  checking ${cmd/%\ */} ..."
463         if ! $cmd >/dev/null; then
464             echo "error: command \"$cmd\" failed"
465             exit 1
466         fi
467     done
468
469     echo
470     echo "Checking for External network:"
471     for net in $(neutron net-list --router:external True -c name -f value); do
472         echo "  external network: $net"
473     done
474
475     # install yardstick
476     install_yardstick
477
478     cleanup
479
480     trap "error_exit" EXIT SIGTERM
481
482     QCOW_IMAGE="/tmp/workspace/yardstick/yardstick-trusty-server.img"
483
484     if [ "$DEPLOY_SCENARIO" == "os-nosdn-lxd-ha" -o "$DEPLOY_SCENARIO" == "os-nosdn-lxd-noha" ]; then
485         DISK_FORMAT="raw"
486     else
487         DISK_FORMAT="qcow2"
488     fi
489
490     build_yardstick_image
491     load_yardstick_image
492     if [ $YARD_IMG_ARCH = "arm64" ]; then
493         sed -i 's/image: cirros-0.3.3/image: TestVM/g' tests/opnfv/test_cases/opnfv_yardstick_tc002.yaml \
494         samples/ping.yaml
495         #We have overlapping IP with the real network
496         for filename in tests/opnfv/test_cases/*; do
497             sed -i "s/cidr: '10.0.1.0\/24'/cidr: '10.3.1.0\/24'/g" $filename
498         done
499     else
500         load_cirros_image
501         load_ubuntu_image
502     fi
503     create_nova_flavor
504     install_storperf
505     run_test
506     remove_storperf
507 }
508
509 main